import es, os, os.path
class downloadables:
    def __init__(self):
        self.dls = []
        self.root = "%s/" % str(es.ServerVar('eventscripts_gamedir')).replace('\\','/')
    def add(self,path,ignore=None):
        path = path.replace('\\','/')
        if path.startswith('/'):
            path = path[1:]
        object = self.root + path
        if not type(ignore) == list:
            ignore = [ignore]
        if os.path.isfile(object) and path not in self.dls:
            es.dbgmsg(1,'adding: %s' % path)
            self.dls.append(path)
        elif os.path.isdir(object):
            if not path.endswith('/'):
                path += '/'
            filelist = getRecursiveList(path,object,ignore)
            for thing in filelist:
                if not thing in self.dls:
                    es.dbgmsg(1,'adding: %s' % thing)
                    self.dls.append(thing)
        else:
            es.dbgmsg(0,'%s is not a folder or file' % object)
    def apply(self):
        for dl in self.dls:
            es.dbgmsg(1,'applying %s' % dl)
            es.stringtable('downloadables', dl)
    def remove(self,path):
        path = path.replace('\\','/')
        if path.startswith('/'):
            path = path[1:]
        object = os.path.join(self.root,path)
        if os.path.isfile(object) and path in self.dls:
            es.dbgmsg(1,'removing: %s' % thing)
            self.dls.remove(path)
        elif os.path.isdir(object):
            if not path.endswith('/'):
                path += '/'
            filelist = getRecursiveList(path,object)
            for thing in filelist:
                if thing in self.dls:
                    es.dbgmsg(1,'removing: %s' % thing)
                    self.dls.remove(thing)
            
def getRecursiveList(relativ,absolut,ignore):
    rl = []
    for root, dirs, files in os.walk(absolut):
        current = root.replace(absolut,'')
        for f in files:
            if not doIgnore(f,ignore):
                rl.append(relativ + f)
    return rl
    
def doIgnore(name,ignore):
    for i in ignore:
        if name.endswith(i):
            return True
    return False